//'*****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2006                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************/

// -------------------------------------------------------------------
// FVX Sample Program
// C_CAO
//
// 쐬 : R.Nagashima
//
//  : 2007/03/08 
// -------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FVDATASLib;

namespace RSearch
{
	public partial class frmPtnDisp : Form
	{
		public frmPtnDisp()
		{
			InitializeComponent();
		}

		public frmMain m_Owner;


		private void frmPtnDisp_Load(object sender, EventArgs e)
		{
			m_Owner = (frmMain)this.Owner;//etH[
			
			axFvxDisplayEx1.CreateDisplay();

			m_Owner.ApplyChanges();
		}
		//tH[\Cxg
		private void frmPtnDisp_Shown(object sender, EventArgs e)
		{
			double dblMagnification;

			//\{擾
			dblMagnification = fnGetMag();
			
			//fBXvCTCYύX
			DisplayResize(dblMagnification);
	
			//GbW\
			EdgeDataDisp();
		}			

		//\{擾
		private double fnGetMag()
		{
			double dblMagnification;

			dblMagnification = (double)hScrollImageScale.Value;
			dblMagnification = (dblMagnification - ((dblMagnification - 1) * 0.5));

			return(dblMagnification);
		}

		//fBXvCEt[TCYύX
		private void DisplayResize(double dblMagnification)
		{
			double dblXPos;
			double dblYPos;
			FvRectangle pRect = new FvRectangle();
			double dblPatternXSize;
			double dblPatternYSize;
			int intMinWidth;
			int intMinHeight;

			m_Owner.axFvxPattern1.GetCenterMarkOffset(out dblXPos, out dblYPos);//ʒmW̎擾
			m_Owner.axFvxPattern1.GetPatternArea(pRect);//p^̈̎擾

			dblPatternXSize = pRect.xe - pRect.xs + 1;
			dblPatternYSize = pRect.ye - pRect.ys + 1;

			this.Width = (int)((dblPatternXSize * dblMagnification) + 150);//tH[̃TCYݒ
			this.Height = (int)((dblPatternYSize * dblMagnification) + 150);


			intMinWidth = (200 + 50);
			intMinHeight = (180 + 50);

			if (this.Width < intMinWidth)
				this.Width = intMinWidth;
			if (this.Height < intMinHeight)
				this.Height = intMinHeight;

			axFvxDisplayEx1.Magnification = dblMagnification;
			axFvxDisplayEx1.DrawImage(m_Owner.axFvxPattern1.GetOcx());
		}
		
		//GbW\
		private void EdgeDataDisp()
		{
			int Kind = 1;
			int Mode = 0;
			
			axFvxDisplayEx1.PenColor = Color.Blue;

			if (chkEdgeDisp.Checked == true) Mode = 2;
			else Mode = 0;

			m_Owner.EdgeDisp(Kind, Mode);
		}

		//GbW\ ON/OFF
		private void chkEdgeDisp_CheckedChanged(object sender, EventArgs e)
		{
			short shtKind, shtMode;

			shtKind = 1;

			if (chkEdgeDisp.Checked == true)	//GbW\
			{
				shtMode = 2;
				m_Owner.EdgeDisp(shtKind, shtMode);
			}
			else//GbW
			{
				shtMode = 0;
				m_Owner.EdgeDisp(shtKind, shtMode);

				PatanCenterMarkDisp();
			}
		}

		//p^ʒmʒuW(l)\
		public void PatanCenterMarkDisp()
		{
			double dblXPos, dblYPos;

			//ʒmʒu\
			m_Owner.axFvxPattern1.GetCenterMarkOffset(out dblXPos, out dblYPos);

			lblCenterMark.Text = string.Format("ʒmʒu( {0:0.00} , {1:0.0} ) ", dblXPos, dblYPos);
			fnCrossCursor(dblXPos, dblYPos);
		}

		//\`
		public void fnCrossCursor(double dblXPos, double dblYPos)
		{
			FvLineSegment pLine1 = new FvLineSegment();
			int intID1;

			pLine1.xs = dblXPos - 5;
			pLine1.ys = dblYPos - 5;
			pLine1.xe = dblXPos + 5;
			pLine1.ye = dblYPos + 5;
			intID1 = axFvxDisplayEx1.DrawData(1, pLine1);

			pLine1.xs = dblXPos + 5;
			pLine1.ys = dblYPos - 5;
			pLine1.xe = dblXPos - 5;
			pLine1.ye = dblYPos + 5;
			intID1 = axFvxDisplayEx1.DrawData(1, pLine1);
		}

		private void hScrollImageScale_Scroll(object sender, ScrollEventArgs e)
		{
			double dblMagnification;
			dblMagnification = (double)hScrollImageScale.Value;
			dblMagnification = (dblMagnification - ((dblMagnification - 1) * 0.5));
			lblImageScale.Text = string.Format("~{0:0.0}",dblMagnification);
			DisplayResize(dblMagnification);
		}

		private void frmPtnDisp_FormClosed(object sender, FormClosedEventArgs e)
		{
			axFvxDisplayEx1.DestroyDisplay();
		}

	}
}